## deal.ii 7.1.0

=== Makefile ===
# $Id: Makefile 22698 2010-11-11 21:27:55Z kanschat $
#
# Makefile for the whole library

SHELL=/bin/bash

help:
	@echo "========================================================================"
	@echo "=              Global Makefile for the deal.II libraries               ="
	@echo "========================================================================"
	@echo "=                                                                      ="
	@echo "= The following targets exist:                                         ="
	@echo "=    all        : debug and optimized libraries                        ="
	@echo "=    debug      : the debug version of the deal.II library             ="
	@echo "=    optimized  : the optimized version of the deal.II library         ="
	@echo "=                                                                      ="
	@echo "=    contrib    : additional libraries in contrib, if there are any    ="
	@echo "=                                                                      ="
	@echo "=    online-doc : generate the documentation in HTML format            ="
	@echo "=    TODO       : create a \"TODO\" file from the source files           ="
	@echo "=    TAGS       : create a TAGS file from include and source files     ="
	@echo "=                                                                      ="
	@echo "=    clean      : removes all object files in subdirs                  ="
	@echo "=    distclean  : removes all object files, libraries, etc in subdirs  ="
	@echo "========================================================================"

deps:
	@cd common/scripts && $(MAKE) $(MAKEOPTIONS)
	@cd source && if $(MAKE) $(MAKEOPTIONS) Makefile.dep;\
	  then : ;\
	  else rm Makefile.dep && $(MAKE) $(MAKEOPTIONS) Makefile.dep; fi
	@cd lib && $(MAKE) $(MAKEOPTIONS) external-links


all: debug optimized

debug: deps contrib
	@cd source && $(MAKE) debug

optimized: deps contrib
	@cd source && $(MAKE) optimized

contrib:
	@cd contrib && $(MAKE)

online-doc doc:
	cd doc && $(MAKE)
	@echo
	@echo
	@echo =======================================================
	@echo "The online documentation can now be accessed through"
	@echo "  doc/index.html"
	@echo =======================================================
	@echo
	@echo

TODO:
	@egrep -i '// *todo' include/deal.II/*/*.h source/*/*.cc \
	| perl common/scripts/make_todo.pl > $@


TAGS:
	@cd common ; etags --language=c++ \
	../include/deal.II/*/*.h ../source/*/*.cc \
	../examples/*/*.cc ; \
	perl -pi -e 's/ \* .*//g; s&[\t]*/\*.*&&g; s&[\t]*\*/.*&&g;' TAGS


clean: clean-contrib clean-source \
       clean-doc clean-examples clean-lib clean-tests
	-rm -f TODO common/TAGS

clean-contrib:
	@cd contrib && $(MAKE) clean

clean-source:
	@cd source && $(MAKE) CLEAN=yes clean

clean-doc:
	@cd doc && $(MAKE) CLEAN=yes clean

clean-examples:
	@cd examples && $(MAKE) CLEAN=yes clean

clean-lib:
	@cd lib && $(MAKE) CLEAN=yes clean

# if that directory exists, go into 'tests' and clean up there as well
clean-tests:
	@-cd tests && $(MAKE) clean

clean-common-scripts:
	@cd common/scripts && $(MAKE) clean

distclean: clean
	@cd lib && $(MAKE) distclean
	@-cd tests && $(MAKE) distclean
	@-rm source/*/*.inst
	@$(MAKE) clean-common-scripts



# #############################################################################
# targets for build tests. these targets are supposed to be called for regular
# build tests that send their results back home to our build test server. note
# that this target is supposed to be called right after checking out a version
# from our CVS server, so at this time, common/Make.global_options doesn't
# exist yet (and isn't included at the top of this file, due to a
# conditional), and we first have to set up all this stuff.
#
# the way this target works is that it first generates a bunch of lines for
# the output file that will ultimately be sent home. it then calls ./configure
# and stashes away both the output and the return value. if ./configure
# succeeds, we extract a little more information concluding the
# header. irrespective of this, we then append the output of ./configure to
# the log file. if the call to ./configure failed, we send the result back
# home and exit.
#
# if ./configure succeeded, we then go on to the build-test-do target, which
# actually compiles something, and when we come back from there we send the
# whole thing over to the server
build-test:
	echo AUTOMATED DEAL.II BUILD TEST          | tee    build-test-log
	-(./configure $(BUILDTESTFLAGS) 2>&1) > build-test-config
	echo BEGIN HEADER `date -u '+%Y-%m-%d %T'`        | tee -a build-test-log
	(cd common ; $(MAKE) BUILDTEST=yes -f Make.global_options print-summary) | tee -a build-test-log
	echo END HEADER `date -u '+%Y-%m-%d %T'`             | tee -a build-test-log
	echo                                  | tee -a build-test-log
	echo BEGIN CONFIGURE OUTPUT `date -u '+%Y-%m-%d %T'` | tee -a build-test-log
	cat build-test-config                 | tee -a build-test-log
	echo END CONFIGURE OUTPUT `date -u '+%Y-%m-%d %T'`   | tee -a build-test-log
	echo                                  | tee -a build-test-log
	-$(MAKE) BUILDTEST= build-test-do 2>&1 | tee -a build-test-log

# target to do the actual compilation tests for an automated build test. build
# the library, the example programs, and the doxygen example programs. if the
# testsuite has been checked out, run that, too, and send the results to the
# testsuite server
build-test-do:
	@echo BEGIN MAKE LIB OUTPUT `date -u '+%Y-%m-%d %T'`
	$(MAKE) all
	@echo END MAKE LIB OUTPUT `date -u '+%Y-%m-%d %T'`
	@echo
	@echo BEGIN MAKE EXAMPLES OUTPUT `date -u '+%Y-%m-%d %T'`
	cd examples ; $(MAKE)
	@echo END MAKE EXAMPLES OUTPUT `date -u '+%Y-%m-%d %T'`
	@echo
	@echo BEGIN MAKE RUN EXAMPLES OUTPUT `date -u '+%Y-%m-%d %T'`
	cd examples/doxygen ; $(MAKE) run
	@echo END MAKE RUN EXAMPLES OUTPUT `date -u '+%Y-%m-%d %T'`
	@echo
	@echo BUILD TEST SUCCESSFUL `date -u '+%Y-%m-%d %T'`


.PHONY: all \
        online-doc doc printable-doc tex-doc contrib \
        clean clean-contrib clean-base clean-lac clean-dealII \
	clean-doc clean-examples clean-lib clean-tests clean-common-scripts \
	distclean \
	build-test build-test-do \
	TAGS TODO

# mark the following two as phony since they mark two actual files but
# we don't want to list the full dependencies here. let the sub-makefiles
# do that
.PHONY: common/scripts/make_dependencies \
        common/scripts/expand_instantiations

=== examples/Makefile ===
# $Id: Makefile 22321 2010-10-12 21:53:08Z kanschat $
#
# This Makefile only recurses into the subdirs
include ../common/Make.global_options

all: default

# existing examples. take dirnames and strip 'step'
steps = $(shell echo step-? step-??)


# default is: build all examples. for each example, there is a target
# build-step-N, where N in [1...]
default: $(addprefix build-,$(steps)) doxygen

# run example programs; make a target run-step-N for each N
run: $(addprefix run-,$(steps)) run-doxygen

# clean subdirs; make a target clean-step-N for each N
clean:
	-rm -f *~ */*~ */*.$(OBJEXT) */*gmv */*gnuplot */*gpl */*eps */*pov */*tex \
	$(addsuffix $(EXEEXT),$(basename $(shell echo step-*/step-*.cc))) \
	doxygen/*.o doxygen/*.exe */Makefile.dep

# Create plain.cc in each subdirectory
plain: $(steps)
	for step in $(steps) ; do cd $$step; perl $D/doc/doxygen/tutorial/program2plain $$step.cc > plain.cc ; cd .. ; done

# for each build/run/clean target: strip the build- prefix of the
# target and build in that directory
build-step-%:
	cd $(@:build-%=%) ; $(MAKE)
run-step-%:
	cd $(@:run-%=%) ; $(MAKE) run
clean-step-%:
	cd $(@:clean-%=%) ; $(MAKE) clean
doxygen:
	cd doxygen ; $(MAKE)
run-doxygen:
	cd doxygen ; $(MAKE) run
clean-doxygen:
	cd doxygen ; $(MAKE) clean

# all targets in this directory do not produce files, so they are
# .PHONY:
.PHONY: $(addprefix build-step-,$(steps)) \
        $(addprefix run-step-,$(steps))   \
        $(addprefix clean-step-,$(steps)) \
	doxygen doxygen-run doxygen-clean

=== lib/Makefile ===
# $Id: Makefile 23821 2011-06-15 03:28:55Z bangerth $

D = ..

# get options which hold for all files of the project
include $D/common/Make.global_options


default:
	@echo There is no default target in this directory


######################### EXTERNAL LINK TARGETS ###################
# link in external libs, if any
external-links: external-links-petsc

ifeq ($(USE_CONTRIB_PETSC),yes)

  # PETSc has the nasty habit of putting debug and optimized builds into
  # different directories, but naming the respective libraries the same.
  # Since one doesn't want to always set and reset $LD_LIBRARY_PATH when
  # one switches from debug to optimized mode, they pass -Wl,-rpath to
  # the linker line. This is not really portable, and it has the additional
  # drawback that one has to pass different linker flags for debug and
  # optimized mode. The latter is a problem with our present build system,
  # which allows to use different libraries, but doesn't take into account
  # that one may want to pass different $LDFLAGS.
  #
  # To avoid such hassle, we build some kind of convenience library: a shared
  # library that has no content, but contains references to all the different
  # PETSc libraries, and we build one for debug and one for optimized mode.
  # We can't really get around the use of -Wl,-rpath, but at least we
  # have now centralized this part to one single place, and are back to where
  # we want to be: have different libraries for debug and optimized mode,
  # but in the same directory. And, voila, our build system works again :-)
  #
  # There is one gotcha: PETSc has a habit of making incompatible changes by
  # simply changing the names of libraries between different versions. That
  # really is too bad, so we have to conditionalize things.
ifeq ($(DEAL_II_PETSC_VERSION_MINOR),1)
  xlib-ksp=libpetscsles
else
  xlib-ksp=libpetscksp
endif
  # This is how it is done. Starting with PETSc versions 2.3.*:
ifeq ($(DEAL_II_PETSC_VERSION_MAJOR),2)
  xlib.g = $(lib-contrib-petsc-path.g)/libpetscksp$(lib-suffix) \
           $(lib-contrib-petsc-path.g)/libpetscdm$(lib-suffix)  \
           $(lib-contrib-petsc-path.g)/libpetscmat$(lib-suffix) \
           $(lib-contrib-petsc-path.g)/libpetscvec$(lib-suffix) \
           $(lib-contrib-petsc-path.g)/libpetsc$(lib-suffix)
  xlib.o = $(lib-contrib-petsc-path.o)/libpetscksp$(lib-suffix) \
           $(lib-contrib-petsc-path.o)/libpetscdm$(lib-suffix)  \
           $(lib-contrib-petsc-path.o)/libpetscmat$(lib-suffix) \
           $(lib-contrib-petsc-path.o)/libpetscvec$(lib-suffix) \
           $(lib-contrib-petsc-path.o)/libpetsc$(lib-suffix)
else
  # which is the same for PETSc 3.0.0:
  ifeq ($(DEAL_II_PETSC_VERSION_MAJOR)$(DEAL_II_PETSC_VERSION_MINOR),30)
    xlib.g = $(lib-contrib-petsc-path.g)/libpetscksp$(lib-suffix) \
             $(lib-contrib-petsc-path.g)/libpetscdm$(lib-suffix)  \
             $(lib-contrib-petsc-path.g)/libpetscmat$(lib-suffix) \
             $(lib-contrib-petsc-path.g)/libpetscvec$(lib-suffix) \
             $(lib-contrib-petsc-path.g)/libpetsc$(lib-suffix)
    xlib.o = $(lib-contrib-petsc-path.o)/libpetscksp$(lib-suffix) \
             $(lib-contrib-petsc-path.o)/libpetscdm$(lib-suffix)  \
             $(lib-contrib-petsc-path.o)/libpetscmat$(lib-suffix) \
             $(lib-contrib-petsc-path.o)/libpetscvec$(lib-suffix) \
             $(lib-contrib-petsc-path.o)/libpetsc$(lib-suffix)
  else
    # but after that (petsc-3.1++), we can use the simpler PETSc
    # default "--with-single-library=1" like this:
    xlib.g = $(lib-contrib-petsc-path.o)/libpetsc$(lib-suffix)
    xlib.o = $(lib-contrib-petsc-path.o)/libpetsc$(lib-suffix)
  endif
endif

ifeq ($(enable-shared),yes)

  external-links-petsc: libpetscall.g$(shared-lib-suffix) libpetscall$(shared-lib-suffix)

  libpetscall.g$(shared-lib-suffix): $(xlib.g)
	@echo "======================debug============= Linking library:   libpetscall.g$(shared-lib-suffix)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,petscall.g) $(call DEAL_II_ADD_SONAME,petscall.g) $(xlib.g)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,petscall.g) $@

  libpetscall$(shared-lib-suffix): $(xlib.o)
	@echo "======================optimized========= Linking library:   libpetscall$(shared-lib-suffix)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,petscall) $(call DEAL_II_ADD_SONAME,petscall)  $(xlib.o)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,petscall) $@

else

  # make static libraries. ensure that they are built one after the other because
  # both create temporary files with the same name
  external-links-petsc:
	@$(MAKE) libpetscall.g$(static-lib-suffix)
	@$(MAKE) libpetscall$(static-lib-suffix)

  # As I don't know how to merge archives, here's a workaround: Extract each of
  # the archives and append the object files to the libpetsc archive. Do the
  # same for debug and optimized mode.
  libpetscall.g$(static-lib-suffix): $(xlib.g)
	@echo "======================debug============= Linking library:   libpetscall.g$(static-lib-suffix)"
	@rm -f $@
	@rm -rf .ar_tmp
	@mkdir .ar_tmp; cd .ar_tmp; \
	 for arfile in $(xlib.g) ; do \
	   $(AR) x $$arfile; \
           $(AR) q ../libpetscall.g$(static-lib-suffix) *; \
           rm *; \
	 done
	@cd ..
	@rm -r .ar_tmp
	@$(RANLIB) libpetscall.g$(static-lib-suffix)

  libpetscall$(static-lib-suffix): $(xlib.o)
	@echo "======================optimized========= Linking library:   libpetscall$(static-lib-suffix)"
	@rm -f $@
	@rm -rf .ar_tmp
	@mkdir .ar_tmp; cd .ar_tmp; \
	 for arfile in $(xlib.o) ; do \
	   $(AR) x $$arfile; \
           $(AR) q ../libpetscall$(static-lib-suffix) *; \
           rm *; \
	 done
	@cd ..
	@rm -r .ar_tmp
	@$(RANLIB) libpetscall$(static-lib-suffix)
endif


else
  external-links-petsc:
endif



######################### CLEAN TARGETS ###################
# clean everything
clean: clean-objects

# only clean object files, not libraries and executables
clean-objects:  clean-debug clean-optimized \
		clean-contrib


# clean targets for the individual subdirectories. remove
# object files and template instantiation files.
# extract dir name from target
clean-debug clean-optimized:
	-cd $(@:clean-%=%) ; rm -f *.$(OBJEXT) *.ti *.ii

clean-contrib:
	-rm contrib/*/*.$(OBJEXT)
	-rm -r contrib/tbb/*debug
	-rm -r contrib/tbb/*release

distclean: clean
	-rm -f lib* bin/*
	-rm bin/detached_ma27
	-rm bin/dealii_parameter_gui
	-rm libtbb*

.PHONY: clean clean-objects
.PHONY: clean-base clean-lac clean-1d clean-2d clean-3d
.PHONY: clean-contrib
.PHONY: external-links external-links-petsc

=== source/Makefile ===
# $Id: Makefile 24313 2011-09-12 06:37:07Z bangerth $
# Copyright W. Bangerth, University of Heidelberg, 1998, 1999, 2000, 2001, 2002, 2010, 2011


ifneq ($(CLEAN),yes)

# deal.II top level directory
D=..


# get options which hold for all files of the project
include $D/common/Make.global_options

# top level targets
default all: debug optimized


# list the directories and the various kinds of files, the ones with the
# largest compile jobs first so that 'make -j N' saturates many processors
# also towards the end of compiling (e.g. numerics/vectors.cc takes several
# minutes to compile...)
all-dirs      := numerics fe dofs lac base grid hp multigrid distributed

cc-files      := $(shell for i in $(all-dirs) ; do echo $D/source/$$i/*.cc ; done)
h-files       := $(sort $(shell echo $D/include/deal.II/*/*.h))

inst-in-files := $(shell echo */*.inst.in)
inst-files    := $(inst-in-files:%.in=%)


# build unique object file names
tmp1               := $(shell echo $(cc-files) | $(PERL) -pi -e 's,$D/source/,,g; s,/,_,g;')
tmp-o-files-indep  := $(addprefix $(LIBDIR)/optimized/, $(tmp1:.cc=.$(OBJEXT)) )
tmp-go-files-indep := $(addprefix $(LIBDIR)/debug/, $(tmp1:.cc=.$(OBJEXT)))

o-files  := $(tmp-o-files-indep)
go-files := $(tmp-go-files-indep)


debug: $(LIBDIR)/libdeal_II.g$(lib-suffix)
optimized: $(LIBDIR)/libdeal_II$(lib-suffix)



# rules how to generate object files from source files.
$(LIBDIR)/debug/%.$(OBJEXT) :
	@echo "======================debug======$(MT)== $(<:$D/source/%=%)"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
$(LIBDIR)/optimized/%.$(OBJEXT) :
	@echo "======================optimized==$(MT)== $(<:$D/source/%=%)"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@



%.inst : %.inst.in $D/common/template-arguments
	@echo "===================================== $(@F)"
	@$D/common/scripts/expand_instantiations $D/common/template-arguments < $< > $@ || exit 1



# there are extra .o file for the function parser and umfpack that we
# need to link into out library
ifeq ($(enable-parser),yes)
  extra-o-files   := $(LIBDIR)/contrib/functionparser/fparser.$(OBJEXT)
  extra-g.o-files := $(LIBDIR)/contrib/functionparser/fparser.$(OBJEXT)
endif

ifeq ($(USE_CONTRIB_UMFPACK),yes)
  umfpack-files   := $(sort $(shell echo $(LIBDIR)/contrib/umfpack/*.$(OBJEXT)))
  extra-o-files   += $(umfpack-files)
  extra-g.o-files += $(umfpack-files)
endif



# in general, when linking shared libraries, we will want to link with
# the underlying libs as well. AIX even requires this. on the other
# hand, on DEC OSF with CXX this will fail with duplicate symbols, so
# make sure that it doesn't happen on that system and that compiler
ifneq ($(GXX-VERSION),compaq_cxx)
  # if we use HSL, then we need to link against libhsl.so.
  ifeq ($(USE_CONTRIB_HSL),yes)
    deplibs.g += $(lib-contrib-hsl)
    deplibs.o += $(lib-contrib-hsl)
  endif

  # same with PETSC
  ifeq ($(USE_CONTRIB_PETSC),yes)
    deplibs.g += $(lib-contrib-petsc.g)
    deplibs.o += $(lib-contrib-petsc.o)
  endif

  # same with SLEPC
  ifeq ($(USE_CONTRIB_SLEPC),yes)
    deplibs.g += $(lib-contrib-slepc)
    deplibs.o += $(lib-contrib-slepc)
  endif

  # same with TRILINOS
  ifeq ($(USE_CONTRIB_TRILINOS),yes)
    deplibs.g += $(lib-contrib-trilinos) \
	         $(call DEAL_II_RPATH,$(DEAL_II_TRILINOS_LIBDIR))
    deplibs.o += $(lib-contrib-trilinos) \
	         $(call DEAL_II_RPATH,$(DEAL_II_TRILINOS_LIBDIR))
  endif

  # same with MUMPS
  ifeq ($(USE_CONTRIB_MUMPS),yes)
    deplibs.g += $(lib-contrib-mumps)
    deplibs.o += $(lib-contrib-mumps)
  endif

  # and METIS
  ifeq ($(USE_CONTRIB_METIS),yes)
    deplibs.g += $(lib-contrib-metis)
    deplibs.o += $(lib-contrib-metis)
  endif

  # also link with TBB
  ifeq ($(enable-threads),yes)
    deplibs.g += $D/lib/libtbb_debug$(shared-lib-suffix)
    deplibs.o += $D/lib/libtbb$(shared-lib-suffix)
  endif

  # and p4est
  ifeq ($(USE_CONTRIB_P4EST),yes)
    deplibs.g += $(DEAL_II_P4EST_DIR)/DEBUG/lib/libp4est$(shared-lib-suffix) \
                 $(DEAL_II_P4EST_DIR)/DEBUG/lib/libsc$(shared-lib-suffix) \
		 $(call DEAL_II_RPATH,$(DEAL_II_P4EST_DIR)/DEBUG/lib)
    deplibs.o += $(DEAL_II_P4EST_DIR)/FAST/lib/libp4est$(shared-lib-suffix) \
                 $(DEAL_II_P4EST_DIR)/FAST/lib/libsc$(shared-lib-suffix) \
		 $(call DEAL_II_RPATH,$(DEAL_II_P4EST_DIR)/FAST/lib)
  endif

  # for cygwin and darwin, also llapack and such are necessary
  # we better link all libraries mentioned in $(LIBS)
  ifneq ($(findstring cygwin,$(TARGET))$(findstring darwin,$(TARGET)),)
    deplibs.g += $(LIBS)
    deplibs.o += $(LIBS)
  endif

else
  deplibs.g =
  deplibs.o =
endif


# rules for static libraries
$(LIBDIR)/libdeal_II.g$(static-lib-suffix): $(go-files) $(extra-g.o-files)
	@echo "=====deal.II==========debug======$(MT)== Linking library:   $(@F)"
	@$(AR) ru $@ $(go-files) $(extra-g.o-files)
	@$(RANLIB) $@
$(LIBDIR)/libdeal_II$(static-lib-suffix): $(o-files) $(extra-o-files)
	@echo "=====deal.II==========optimized==$(MT)== Linking library:   $(@F)"
	@$(AR) ru $@ $(o-files) $(extra-o-files)
	@$(RANLIB) $@


# Rules for shared libraries. these are much more difficult to link
# because the linker has to update relocations etc. This requires
# seeking back and forth in memory mapped files and is excruciatingly
# slow on remotely mounted file systems. Consequently, we link in a
# local file in the $TMPDIR directory, and only after the fact move
# them to their final location
$(LIBDIR)/libdeal_II.g$(shared-lib-suffix): $(go-files) $(extra-g.o-files)
	@echo "=====deal.II==========debug======$(MT)== Linking library:   $(@F)"
	@rm -f $@
	@WORKFILE=`mktemp $${TMPDIR:-/tmp}/tmp.XXXXXXXXXX` && \
		$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $$WORKFILE $(call DEAL_II_ADD_SONAME,deal_II.g) $(go-files) $(extra-g.o-files) $(deplibs.g) && \
	 	mv $$WORKFILE $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,deal_II.g)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,deal_II.g) $@

$(LIBDIR)/libdeal_II$(shared-lib-suffix): $(o-files) $(extra-o-files)
	@echo "=====deal.II==========optimized==$(MT)== Linking library:   $(@F)"
	@rm -f $@
	@WORKFILE=`mktemp $${TMPDIR:-/tmp}/tmp.XXXXXXXXXX` && \
		$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $$WORKFILE $(call DEAL_II_ADD_SONAME,deal_II) $(o-files) $(extra-o-files) $(deplibs.o) && \
		mv $$WORKFILE $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,deal_II)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,deal_II) $@



# generate a file that contains prototypes for BLAS and LAPACK functions
../include/deal.II/lac/lapack_templates.h: ../include/deal.II/lac/lapack_templates.h.in \
						$D/common/scripts/lapack_templates.pl
	@echo ===================================== Remaking $@
	@$(PERL) $D/common/scripts/lapack_templates.pl ../include/deal.II/lac/lapack_templates.h.in > $@


# A rule to make sure the various */Makefile.dep files have the right
# dependencies on their source files. Use the opportunity to also ensure that
# .inst and the lapack file are built before everything else
Makefile.dep: $(inst-files) ../include/deal.II/lac/lapack_templates.h \
		$(cc-files)
	@echo "===================================== Remaking $@"
	@for i in $(all-dirs) ; do \
		echo $$i/Makefile.dep: $$i/*.cc  \
					$(h-files) \
					Makefile \
					$D/common/Make.global_options ; \
	 done >> $@
	@echo "lac/Makefile.dep: $D/include/deal.II/lac/lapack_templates.h.in \
				 $D/include/deal.II/lac/lapack_templates.h.in" \
	 >> $@
include Makefile.dep


# Rule to generate the dependency files, one for each source
# directory. These file are automagically remade whenever needed,
# i.e. whenever one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion below.
#
# If the command fails, then remove Makefile.dep again and fail
%/Makefile.dep:
	@echo "===================================== Remaking $@"
	@(($D/common/scripts/make_dependencies -n $(INCLUDE) "-B\$$(LIBDIR)" \
			$(filter $D/source/$(dir $@)%, $(cc-files)) \
		| $(PERL) -pe 's!LIBDIR\)/(debug|optimized)/(.*):!LIBDIR)/$$1/$(@:%/Makefile.dep=%)_$$2:!g;' \
	  ) > $@) \
	 || (rm -f $@ ; false)


# include all the dependencies
include $(addsuffix /Makefile.dep, $(all-dirs))

endif



################### some clean-up rules

clean:
	-rm -f Makefile.dep *~ */*~ */*/*~ */Makefile.dep source/*/*.inst \
		$D/lib/{debug,optimized}/*.o


###################

.PHONY: default all debug optimized TAGS
.PHONY: clean

=== common/scripts/Makefile ===
# $Id: Makefile 24263 2011-09-06 12:14:00Z young $
# Copyright W. Bangerth, 2003


# deal.II top level directory
D=../..

include $D/common/Make.global_options

default: make_dependencies$(EXEEXT) expand_instantiations$(EXEEXT) \
         report_features$(EXEEXT)


# rules to generate the program. let is be dependent on the global flags for
# the following reason: if you go to a different system, but keep with the
# same directory, you get into trouble because make_dependencies is not
# deleted by "make clean"; following this, we generate empty Makefile.dep's
# because we can't run the executable. So better be careful and regenerate
# make_dependencies whenever we think it may be beneficial
make_dependencies$(EXEEXT) : make_dependencies.cc $D/common/Make.global_options
	@echo ===================================== Compiling $@
	@$(CXX) $(CXXFLAGS.o) $(LDFLAGS) $< -o $@

expand_instantiations$(EXEEXT) : expand_instantiations.cc $D/common/Make.global_options
	@echo ===================================== Compiling $@
	@$(CXX) $(CXXFLAGS.o) $(LDFLAGS) $< -o $@

report_features$(EXEEXT) : report_features.cc $D/common/Make.global_options
	@echo ===================================== Compiling $@
	@$(CXX) $(CXXFLAGS.o) $(LDFLAGS) $< -o $@

clean:
	-rm -f make_dependencies$(EXEEXT)
	-rm -f make_dependencies.o
	-rm -f expand_instantiations$(EXEEXT)
	-rm -f expand_instantiations.o

.PHONY: clean

=== contrib/hsl/Makefile ===
# $Id: Makefile 22430 2010-10-23 13:41:09Z heister $
# Copyright (C) 2001, 2002, 2003, 2004, 2006, 2008, 2009, 2010 by Wolfgang Bangerth


D = ../..

include $D/common/Make.global_options

# get lists of files we need
f-files     = $(shell a="`echo source/*.f`"; if test "$$a" != "source/*.f" ; then echo $$a ; fi)
o-files     = $(f-files:source/%.f=$(LIBDIR)/contrib/hsl/%.$(OBJEXT))




# rules
lib: $(LIBDIR)/libhsl$(lib-suffix) $(LIBDIR)/bin/detached_ma27$(EXEEXT)



$(LIBDIR)/contrib/hsl/%.$(OBJEXT) :
	@echo =====hsl==============optimized==$(MT)== $(<F)
	@$(F77) $(F77FLAGS.o) -c $< -o $@


$(LIBDIR)/contrib/hsl/detached_ma27.$(OBJEXT) : source/detached_ma27.cc \
						include/hsl/hsl.h
	@echo =====hsl==============optimized==$(MT)== $(<F)
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@


$(LIBDIR)/libhsl$(static-lib-suffix): $(forward-declarations) $(o-files)
	@echo =====hsl==============optimized==$(MT)== Linking library:   $(@F)
	@$(AR) ru $@ $(o-files)
	@$(RANLIB) $@

# link the object files to a shared library.
$(LIBDIR)/libhsl$(shared-lib-suffix): $(forward-declarations) $(o-files)
	@echo =====hsl==============optimized==$(MT)== Linking library:   $(@F)
	@$(SHLIBLD) $(LDFLAGS) -shared -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,hsl) $(call DEAL_II_ADD_SONAME,hsl) $(o-files) $(F77LIBS)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,hsl) $@



# rule to make the program that runs an MA27 solver detached from the
# main program, and communicates through a pipe. since this program
# has actually nothing much to do, compile it in debug mode
$(LIBDIR)/bin/detached_ma27$(EXEEXT):  \
				$(LIBDIR)/contrib/hsl/detached_ma27.$(OBJEXT) \
				$(LIBDIR)/libhsl$(lib-suffix)
	@echo =====hsl=========================$(MT)== Making   $(@F)
	@$(CXX) $(CXXFLAGS.g) $^ -o $@ $(F77LIBS) -lpthread $(LIBS)



clean:
	-rm -f $(LIBDIR)/contrib/hsl/*.$(OBJEXT) $(LIBDIR)/libhsl$(lib-suffix) \
		$(LIBDIR)/bin/detached_ma27$(EXEEXT) \
		Makefile.dep



# Rule to generate the dependency file. This file is
# automagically remade whenever needed, i.e. whenever
# one of the f-files changed. Make detects whether
# to remake this file upon inclusion at the bottom
# of this file.
#
# note that we take care if there are no f-files
#
# If the command fails, then remove Makefile.dep again and fail
Makefile.dep: $(f-files) Makefile
	@echo ============================ Remaking Makefile
	@(if test "x$(f-files)" != "x" ; then \
           for i in source/*.f ; do \
	     echo $$i | $(PERL) -pi -e 's#source/(.*)\.f#\$$(LIBDIR)/contrib/hsl/\1.$(OBJEXT):source/\1.f#;' ;\
	    done ; \
          fi) \
		> $@ \
	 || (rm -f $@ ; false)


# include all the dependencies
include Makefile.dep


.PHONY: clean
.PHONY: lib lib$(static-lib-suffix) lib.g$(static-lib-suffix)

=== contrib/tbb/Makefile ===
# bild the tbb libraries. they end up in directories with weird names that contain
# the system and compiler names etc. rename them to something that's a bit more
# predictable for the downstream make files.
tbb:
	@cd tbb30_104oss ; $(MAKE) tbb tbb_build_dir=$D/lib/contrib/tbb
	@rm -f $D/lib/libtbb*
	@for i in $D/lib/contrib/tbb/*_debug/libtbb_debug* ; do \
	    ln -s -f $$i $D/lib/`echo $$i | $(PERL) -pi -e 's#.*/##g;'` ; done
	@for i in $D/lib/contrib/tbb/*_release/libtbb* ; do \
	    ln -s -f $$i $D/lib/`echo $$i | $(PERL) -pi -e 's#.*/##g;'` ; done


# nothing to do here: tbb builds everything in $D/lib/contrib/tbb
clean:

.PHONY: tbb clean

include ../../common/Make.global_options

=== doc/development/Makefile ===
# $Id: Makefile 22624 2010-11-07 20:11:10Z bangerth $


D = ../..
include $D/common/Make.global_options


default: makefiles.html makefile.small.html makefile.large.html


# Have a list of variables defined in common/Make.global_options and expand them into
# something that looks decent in HTML. The special text "--break--" draws a horizontal
# line to separate different blocks of variables
VARIABLES =     D DEAL_II_VERSION DEAL_II_MAJOR DEAL_II_MINOR \
	--break-- \
		CXX GXX-VERSION GXX-VERSION-DETAILED \
		CC CC-VERSION \
		F77 F77-VERSION \
		SHLIBLD \
		AR \
		RANLIB \
		PERL \
		TARGET \
	--break-- \
		LIBPATH \
		LIBDIR \
		LIBS \
		OBJEXT EXEEXT static-lib-suffix shared-lib-suffix \
		lib-suffix \
	--break-- \
		lib-deal2.o \
		lib-deal2.g \
	--break-- \
		INCLUDE \
		CXXFLAGS.g \
		CXXFLAGS.o \
		CFLAGS.g \
		CFLAGS.o \
		F77FLAGS.g \
		F77FLAGS.o \
		SHLIBFLAGS \
		LDFLAGS \
		F77LIBS \
	--break-- \
		enable-shared \
		enable-parser \
		DEAL_II_USE_MPI \
	--break-- \
		enable-threads \
		lib-contrib-tbb.g \
		lib-contrib-tbb.o \
	--break-- \
		USE_CONTRIB_UMFPACK \
	--break-- \
		USE_CONTRIB_HSL \
		lib-contrib-hsl \
	--break-- \
		USE_CONTRIB_PETSC \
		DEAL_II_PETSC_DIR \
		DEAL_II_PETSC_ARCH \
		DEAL_II_PETSC_VERSION_MAJOR    \
		DEAL_II_PETSC_VERSION_MINOR    \
		DEAL_II_PETSC_VERSION_SUBMINOR \
		DEAL_II_PETSC_MPIUNI_LIB \
		lib-contrib-petsc.g \
		lib-contrib-petsc.o \
		include-path-petsc \
		include-path-petsc-bmake \
	--break-- \
		USE_CONTRIB_SLEPC \
		DEAL_II_SLEPC_DIR \
		DEAL_II_SLEPC_VERSION_MAJOR    \
		DEAL_II_SLEPC_VERSION_MINOR    \
		DEAL_II_SLEPC_VERSION_SUBMINOR \
		lib-contrib-slepc \
		include-path-slepc \
	--break-- \
		USE_CONTRIB_TRILINOS \
		DEAL_II_TRILINOS_INCDIR \
		DEAL_II_TRILINOS_LIBDIR \
		DEAL_II_TRILINOS_SHARED \
		DEAL_II_TRILINOS_STATIC \
		DEAL_II_TRILINOS_VERSION_MAJOR    \
		DEAL_II_TRILINOS_VERSION_MINOR    \
		DEAL_II_TRILINOS_VERSION_SUBMINOR \
		lib-contrib-trilinos \
		include-path-trilinos \
	--break-- \
		USE_CONTRIB_MUMPS  \
		DEAL_II_MUMPS_DIR  \
		DEAL_II_SCALAPACK_DIR \
		DEAL_II_BLACS_DIR  \
		DEAL_II_BLACS_ARCH \
		lib-contrib-mumps \
		include-path-mumps \
	--break-- \
		USE_CONTRIB_ARPACK  \
		DEAL_II_ARPACK_DIR  \
		DEAL_II_ARPACK_ARCH \
		lib-contrib-arpack \
	--break-- \
		USE_CONTRIB_METIS \
		DEAL_II_METIS_DIR \
		lib-contrib-metis \
		include-path-contrib-metis \
	--break-- \
		USE_CONTRIB_P4EST \
		DEAL_II_P4EST_DIR \
	--break-- \
		TECIO_INCLUDE \
		TECIO_LIBRARY

expand_variable = $(if $(1:--break--=), \
			'<tr><td><code>$$($1)</td> <td>$($1)</code></td></tr>',\
			'<tr><th colspan="2"><hr></th></tr>')

VARIABLE_VALUES = $(foreach v,$(VARIABLES),$(call expand_variable,$v))

makefiles.html: Makefile makefiles.1.html $D/common/Make.global_options makefiles.2.html
	@cat makefiles.1.html > $@
	@echo "<p align=\"center\"><table class=\"tutorial\" width=\"60%\">" >> $@
	@echo "<tr><th>Makefile variable</th><th>Value in <code>common/Make.global_options</code></th></tr>" >> $@
	@echo "<tr><th colspan=\"2\"><hr></th></tr>" >> $@
	@echo $(VARIABLE_VALUES) >> $@
	@echo "</table></p>" >> $@
	@cat makefiles.2.html >> $@


makefile.small.html: Makefile.small
	@$(PERL) makefile2html < $< > $@

makefile.large.html: Makefile.large
	@$(PERL) makefile2html < $< > $@

validate-xrefs:
	@$(PERL) $D/common/scripts/validate-xrefs.pl \
		$(filter-out makefiles.1.html makefiles.2.html, \
		  $(shell echo *.html))



clean:
	-rm -f makefiles.html makefile.small.html makefile.large.html

.PHONY: default validate-xrefs clean

=== doc/publications/Makefile ===
# $Id: Makefile 9615 2004-09-14 17:02:20Z guido $

D = ../..
include $D/common/Make.global_options


# default: do nothing
default:


validate-xrefs:
	$(PERL) $D/common/scripts/validate-xrefs.pl *.html


.PHONY: default validate-xrefs

=== examples/doxygen/Makefile ===
###########################################################################
#    $Id: Makefile 22536 2010-10-28 15:08:08Z bangerth $
#    Version: $Name$
#
#    Copyright (C) 1998 - 2007, 2010 by the deal.II authors
#
#    This file is subject to QPL and may not be  distributed
#    without copyright and license information. Please refer
#    to the file deal.II/doc/license.html for the  text  and
#    further information on this license.
#
###########################################################################
include ../../common/Make.global_options

SHELL=/bin/bash

tests = $(wildcard *.cc)
exe =  $(tests:%.cc=%$(EXEEXT))
ok = $(tests:%.cc=%.ok)

all: $(exe)

run: $(ok)
	for prog in $(exe) ; do ./$$prog ; done

######################################################################
# Compilation of source code
######################################################################

./%.g.$(OBJEXT) :
	@echo "==============debug========= $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
./%.$(OBJEXT) :
	@echo ==============optimized===== $(<F)
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@

######################################################################
# Running the programs
######################################################################
%.ok: %$(EXEEXT)
	./$<

######################################################################
# Specific targets
######################################################################

block_matrix_array$(EXEEXT): block_matrix_array.g.$(OBJEXT) $(lib-deal2.g)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)

product_matrix$(EXEEXT): product_matrix.g.$(OBJEXT) $(lib-deal2.g)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)

compressed_block_sparsity_pattern$(EXEEXT): compressed_block_sparsity_pattern.g.$(OBJEXT) $(lib-deal2.g)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)

theta_timestepping$(EXEEXT): theta_timestepping.g.$(OBJEXT) $(lib-deal2.g)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)

######################################################################
# Pseudo target for cleaning directory
######################################################################


clean:
	-rm -f *~ *.$(OBJEXT) $(exe)


.PHONY: all clean

# Finally there is a rule which you normally need not care much about:
# since the executable depends on some include files from the library,
# besides the C++ application file of course, it is necessary to
# re-generate the executable when one of the files it depends on has
# changed. The following rule creates a dependency file
# `Makefile.dep', which `make' uses to determine when to regenerate
# the executable. This file is automagically remade whenever needed,
# i.e. whenever one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom of this file.
#
# If the creation of Makefile.dep fails, blow it away and fail
Makefile.dep: *.cc Makefile \
              $(shell echo $D/include/deal.II/*/*.h)
	@echo ============================ Remaking $@
	@$D/common/scripts/make_dependencies  $(INCLUDE) -B. *.cc \
		> $@ \
	  || (rm -f $@ ; false)
	@if test -s $@ ; then : else rm $@ ; fi



# To make the dependencies known to `make', we finally have to include
# them:
include Makefile.dep

=== examples/step-1/Makefile ===
# $Id: Makefile 24352 2011-09-21 15:12:54Z bangerth $


# For the small projects Makefile, you basically need to fill in only
# four fields.
#
# The first is the name of the application. It is assumed that the
# application name is the same as the base file name of the single C++
# file from which the application is generated.
target = step-1

# The second field determines whether you want to run your program in
# debug or optimized mode. The latter is significantly faster, but no
# run-time checking of parameters and internal states is performed, so
# you should set this value to `on' while you develop your program,
# and to `off' when running production computations.
debug-mode = on


# As third field, we need to give the path to the top-level deal.II
# directory. You need to adjust this to your needs. Since this path is
# probably the most often needed one in the Makefile internals, it is
# designated by a single-character variable, since that can be
# reference using $D only, i.e. without the parentheses that are
# required for most other parameters, as e.g. in $(target).
D = ../../


# The last field specifies the names of data and other files that
# shall be deleted when calling `make clean'. Object and backup files,
# executables and the like are removed anyway. Here, we give a list of
# files in the various output formats that deal.II supports.
clean-up-files = *gmv *gnuplot *gpl *eps *pov *vtk *ucd *.d2




#
#
# Usually, you will not need to change anything beyond this point.
#
#
# The next statement tells the `make' program where to find the
# deal.II top level directory and to include the file with the global
# settings
include $D/common/Make.global_options


# Since the whole project consists of only one file, we need not
# consider difficult dependencies. We only have to declare the
# libraries which we want to link to the object file. deal.II has two
# libraries: one for the debug mode version of the
# application and one for optimized mode.
libs.g   := $(lib-deal2.g)
libs.o   := $(lib-deal2.o)


# We now use the variable defined above to switch between debug and
# optimized mode to select the set of libraries to link with. Included
# in the list of libraries is the name of the object file which we
# will produce from the single C++ file. Note that by default we use
# the extension .g.o for object files compiled in debug mode and .o for
# object files in optimized mode (or whatever local default on your
# system is instead of .o)
ifeq ($(debug-mode),on)
  libraries = $(target).g.$(OBJEXT) $(libs.g)
else
  libraries = $(target).$(OBJEXT) $(libs.o)
endif


# Now comes the first production rule: how to link the single object
# file produced from the single C++ file into the executable. Since
# this is the first rule in the Makefile, it is the one `make' selects
# if you call it without arguments.
$(target)$(EXEEXT) : $(libraries)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)


# To make running the application somewhat independent of the actual
# program name, we usually declare a rule `run' which simply runs the
# program. You can then run it by typing `make run'. This is also
# useful if you want to call the executable with arguments which do
# not change frequently. You may then want to add them to the
# following rule:
run: $(target)$(EXEEXT)
	@echo ============================ Running $<
	@./$(target)$(EXEEXT)


# As a last rule to the `make' program, we define what to do when
# cleaning up a directory. This usually involves deleting object files
# and other automatically created files such as the executable itself,
# backup files, and data files. Since the latter are not usually quite
# diverse, you needed to declare them at the top of this file.
clean:
	-rm -f *.$(OBJEXT) *~ Makefile.dep $(target)$(EXEEXT) $(clean-up-files)


# Since we have not yet stated how to make an object file from a C++
# file, we should do so now. Since the many flags passed to the
# compiler are usually not of much interest, we suppress the actual
# command line using the `at' sign in the first column of the rules
# and write the string indicating what we do instead.
./%.g.$(OBJEXT) :
	@echo "==============debug========= $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
./%.$(OBJEXT) :
	@echo "==============optimized===== $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@


# The following statement tells make that the rules `run' and `clean'
# are not expected to produce files of the same name as Makefile rules
# usually do.
.PHONY: run clean


# Finally there is a rule which you normally need not care much about:
# since the executable depends on some include files from the library,
# besides the C++ application file of course, it is necessary to
# re-generate the executable when one of the files it depends on has
# changed. The following rule creates a dependency file
# `Makefile.dep', which `make' uses to determine when to regenerate
# the executable. This file is automagically remade whenever needed,
# i.e. whenever one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom of this file.
#
# If the creation of Makefile.dep fails, blow it away and fail
Makefile.dep: $(target).cc Makefile \
              $(shell echo $D/include/deal.II/*/*.h)
	@echo ============================ Remaking $@
	@$D/common/scripts/make_dependencies  $(INCLUDE) -B. $(target).cc \
		> $@ \
	  || (rm -f $@ ; false)
	@if test -s $@ ; then : else rm $@ ; fi

# To make the dependencies known to `make', we finally have to include
# them:
include Makefile.dep

=== examples/step-10/Makefile ===
# $Id: Makefile 24352 2011-09-21 15:12:54Z bangerth $


# For the small projects Makefile, you basically need to fill in only
# four fields.
#
# The first is the name of the application. It is assumed that the
# application name is the same as the base file name of the single C++
# file from which the application is generated.
target = step-10

# The second field determines whether you want to run your program in
# debug or optimized mode. The latter is significantly faster, but no
# run-time checking of parameters and internal states is performed, so
# you should set this value to `on' while you develop your program,
# and to `off' when running production computations.
debug-mode = on


# As third field, we need to give the path to the top-level deal.II
# directory. You need to adjust this to your needs. Since this path is
# probably the most often needed one in the Makefile internals, it is
# designated by a single-character variable, since that can be
# reference using $D only, i.e. without the parentheses that are
# required for most other parameters, as e.g. in $(target).
D = ../../


# The last field specifies the names of data and other files that
# shall be deleted when calling `make clean'. Object and backup files,
# executables and the like are removed anyway. Here, we give a list of
# files in the various output formats that deal.II supports.
clean-up-files = *gmv *gnuplot *gpl *eps *pov *vtk *ucd *.d2




#
#
# Usually, you will not need to change anything beyond this point.
#
#
# The next statement tells the `make' program where to find the
# deal.II top level directory and to include the file with the global
# settings
include $D/common/Make.global_options


# Since the whole project consists of only one file, we need not
# consider difficult dependencies. We only have to declare the
# libraries which we want to link to the object file. deal.II has two
# libraries: one for the debug mode version of the
# application and one for optimized mode.
libs.g   := $(lib-deal2.g)
libs.o   := $(lib-deal2.o)


# We now use the variable defined above to switch between debug and
# optimized mode to select the set of libraries to link with. Included
# in the list of libraries is the name of the object file which we
# will produce from the single C++ file. Note that by default we use
# the extension .g.o for object files compiled in debug mode and .o for
# object files in optimized mode (or whatever local default on your
# system is instead of .o)
ifeq ($(debug-mode),on)
  libraries = $(target).g.$(OBJEXT) $(libs.g)
else
  libraries = $(target).$(OBJEXT) $(libs.o)
endif


# Now comes the first production rule: how to link the single object
# file produced from the single C++ file into the executable. Since
# this is the first rule in the Makefile, it is the one `make' selects
# if you call it without arguments.
$(target)$(EXEEXT) : $(libraries)
	@echo ============================ Linking $@
	@$(CXX) -o $@ $^ $(LIBS) $(LDFLAGS)


# To make running the application somewhat independent of the actual
# program name, we usually declare a rule `run' which simply runs the
# program. You can then run it by typing `make run'. This is also
# useful if you want to call the executable with arguments which do
# not change frequently. You may then want to add them to the
# following rule:
run: $(target)$(EXEEXT)
	@echo ============================ Running $<
	@./$(target)$(EXEEXT)


# As a last rule to the `make' program, we define what to do when
# cleaning up a directory. This usually involves deleting object files
# and other automatically created files such as the executable itself,
# backup files, and data files. Since the latter are not usually quite
# diverse, you needed to declare them at the top of this file.
clean:
	-rm -f *.$(OBJEXT) *~ Makefile.dep $(target)$(EXEEXT) $(clean-up-files)


# Since we have not yet stated how to make an object file from a C++
# file, we should do so now. Since the many flags passed to the
# compiler are usually not of much interest, we suppress the actual
# command line using the `at' sign in the first column of the rules
# and write the string indicating what we do instead.
./%.g.$(OBJEXT) :
	@echo "==============debug========= $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
./%.$(OBJEXT) :
	@echo "==============optimized===== $(<F)  ->  $@"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@


# The following statement tells make that the rules `run' and `clean'
# are not expected to produce files of the same name as Makefile rules
# usually do.
.PHONY: run clean


# Finally there is a rule which you normally need not care much about:
# since the executable depends on some include files from the library,
# besides the C++ application file of course, it is necessary to
# re-generate the executable when one of the files it depends on has
# changed. The following rule creates a dependency file
# `Makefile.dep', which `make' uses to determine when to regenerate
# the executable. This file is automagically remade whenever needed,
# i.e. whenever one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom of this file.
#
# If the creation of Makefile.dep fails, blow it away and fail
Makefile.dep: $(target).cc Makefile \
              $(shell echo $D/include/deal.II/*/*.h)
	@echo ============================ Remaking $@
	@$D/common/scripts/make_dependencies  $(INCLUDE) -B. $(target).cc \
		> $@ \
	  || (rm -f $@ ; false)
	@if test -s $@ ; then : else rm $@ ; fi

# To make the dependencies known to `make', we finally have to include
# them:
include Makefile.dep

=== debian/changelog ===
deal.ii (7.1.0-1) unstable; urgency=low

  [ Adam C. Powell, IV ]
  * New upstream (closes: #652057).
  * Updated to use PETSc and SLEPc 3.2, and forward-ported all patches.
  * Removed NetCDF Build-Depends because it uses serial HDF5.
  * Made Sacado cmath patch work with new configure.
  * Moved -dev package symlink lines in rules to arch all section.

  [ Christophe Trophime ]
  * debian/rules:
     - add dh_strip --dbg-package to generate dbg package (closes: #652058)
     - add .install files to simplify rules
  * Add support for mumps, arpack (closes: #637655)
  * Add patch for slepc 3.2 (closes: #659245)

 -- "Adam C. Powell, IV" <hazelsct@debian.org>  Tue, 21 Feb 2012 06:57:30 -0500

=== debian/control ===
Source: deal.ii
Section: devel
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>
Standards-Version: 3.9.2
Build-Depends: debhelper (>= 7), quilt, automake, autoconf, gfortran, zlib1g-dev,
  libblas-dev, liblapack-dev, libpetsc3.2-dev (>= 3.2.dfsg-5), libslepc3.2-dev,
  libtrilinos-dev (>=9.0.2.dfsg-4), libscotchmetis-dev (>= 5.1.4.dfsg-2),
  libsuitesparse-dev, libboost-dev, libboost-graph-dev,
  libboost-python-dev, libtbb-dev, libtbb2-dbg, qt4-qmake, libqt4-dev,
  libarpack2-dev, libmumps-dev, libscalapack-mpi-dev, libblacs-mpi-dev
Build-Depends-Indep: doxygen-latex, graphviz, ghostscript
Vcs-Git: git://git.debian.org/git/debian-science/packages/deal.ii.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/deal.ii.git
Homepage: http://www.dealii.org/

Package: libdeal.ii-dbg7.1.0
Architecture: any
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Finite element library - shared library
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the debugging shared libraries.

Package: libdeal.ii-dbg
Architecture: all
Section: debug
Depends: libdeal.ii-dbg7.1.0 (>= ${source:Version}), ${misc:Depends}
Recommends: libdeal.ii-dev (= ${source:Version}), libtbb2-dbg
Description: Finite element library - development files
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains development files for using debugging shared libraries.

Package: libdeal.ii7.1.0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Finite element library - shared library
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the optimized shared libraries.

Package: libdeal.ii-dev
Architecture: all
Section: libdevel
Depends: libdeal.ii7.1.0 (>= ${source:Upstream-Version}), libdeal.ii7.1.0 (<< ${source:Upstream-Version}+1~), libblas-dev, liblapack-dev, libpetsc3.2-dev, libslepc3.2-dev, libtrilinos-dev (>=9.0.2.dfsg-3), libscotchmetis-dev (>= 5.1.4.dfsg-2), libsuitesparse-dev, libnetcdf-dev, libboost-dev, libtbb-dev, ${misc:Depends}
Suggests: libdeal.ii-dbg, deal.ii-doc, deal.ii-examples
Description: Finite element library - development files
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains development files for using optimized shared libraries.

Package: deal.ii-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Finite element library - documentation
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the documentation.

Package: deal.ii-examples
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: libdeal.ii-dev
Description: Finite element library - documentation
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the tutorial examples' source code.

=== debian/rules ===
#!/usr/bin/make -f
# Made with the aid of debmake, by Christoph Lameter,
# based on the sample debian/rules file for GNU hello by Ian Jackson.

package=deal.ii
version=7.1.0

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         MAKEFLAGS += -j$(NUMJOBS)
endif

patch: stamp-patch
stamp-patch:
	if [ ! -d .pc ]; then \
	  QUILT_PATCHES=debian/patches quilt push -a || test $$? = 2; \
	fi
	if [ ! -e configure.upstream ]; then \
	  cp -a configure configure.upstream; \
	  cp -a include/deal.II/base/config.h.in include/deal.II/base/config.h.in.upstream; \
	fi
	touch $@

clean:
	dh_testdir
	if [ -e common/Make.global_options ]; then $(MAKE) distclean; fi
	if [ -d .pc ]; then \
	  QUILT_PATCHES=debian/patches quilt pop -a -R || test $$? = 2; \
	  rm -rf .pc; \
	fi
	if [ -e configure.upstream ]; then \
	  rm -f configure include/deal.II/base/config.h.in; \
	  mv configure.upstream configure; \
	  mv include/deal.II/base/config.h.in.upstream include/deal.II/base/config.h.in; \
	fi
	rm -f stamp-* install-*
	rm -f config.status config.log
	rm -f contrib/config.status contrib/config.log
	rm -f contrib/utilities/config.status contrib/utilities/config.log

	rm -f common/Make.global_options common/Makefile.template common/Make.global_options
	rm -f common/template-arguments common/scripts/make_dependencies.pl
	rm -f common/scripts/make_todo.pl common/scripts/report_features
	rm -f Version contrib/Makefile contrib/configure contrib/utilities/Makefile contrib/utilities/configure
	rm -f include/deal.II/base/config.h
	rm -f include/deal.II/lac/lapack_templates.h
	rm -rf doc/doxygen/deal.II/search
	rm -f doc/doxygen/header.html doc/doxygen/header.tex
	rm -f doc/doxygen/header.136 doc/doxygen/options.136
	rm -f doc/doxygen/tutorial/toc.html
	rm -f doc/doxygen/Makefile
	rm -f doc/development/makefile.rules.html
	rm -f doc/title.html
	rm -rf lib/contrib
	rm -rf lib/debug lib/optimized lib/bin

	rm -f doc/Makefile doc/doxygen/doxygen.log doc/doxygen/*.dox
	dh_clean

stamp-configure: stamp-patch
	dh_testdir
	aclocal --force
	autoreconf -i -v
	CXX=mpicxx CC=mpicc PETSC_DIR=/usr/lib/petsc PETSC_ARCH=`petscarch` \
	  SLEPC_DIR=/usr/lib/slepc SLEPC_ARCH=linux-gnu-c-opt \
	  ./configure --prefix=/usr --enable-parser --enable-multithreading \
	  --enable-shared \
	  --with-boost-libs=/usr/lib --with-boost-include=/usr/include/boost \
	  --with-blas --with-lapack \
	  --with-umfpack-libs=/usr/lib --with-umfpack-include=/usr/include/suitesparse \
	  --with-metis-libs=/usr/lib --with-metis-include=/usr/include/metis/ \
	  --with-trilinos-libs=/usr/lib --with-trilinos-include=/usr/include/trilinos \
	  --with-netcdf-libs=/usr/lib --with-netcdf-include=/usr/include \
	  --with-arpack=/usr \
	  --with-mumps=/usr --with-scalapack=/usr --with-blacs=/usr
	touch $@

build: build-arch
build-arch: stamp-build-arch
stamp-build-arch: stamp-configure
	dh_testdir
# Move aside Make.global_options and replace it with something temporary
	mv common/Make.global_options common/Make.global_options.orig
	sed 's/$$(LIBDIR)\/lib/-L$$(LIBDIR) -l/' < common/Make.global_options.orig \
	  | sed 's/.g$$(lib-suffix)/.g/' | sed 's/call$$(lib-suffix)/call/' \
	  | sed 's/hsl$$(lib-suffix)/hsl/' | sed 's/ase$$(lib-suffix)/ase/' \
	  | sed 's/lac$$(lib-suffix)/lac/' | sed 's/_1d$$(lib-suffix)/_1d/' \
	  | sed 's/_2d$$(lib-suffix)/_2d/' | sed 's/_3d$$(lib-suffix)/_3d/' \
	  > common/Make.global_options
	$(MAKE) $(MAKEFLAG) optimized
	touch $@

build-indep: stamp-build-indep
stamp-build-indep: stamp-configure
	$(MAKE) $(MAKEFLAG) online-doc
	touch $@

install-arch: build-arch
	touch $@

install-indep: build-indep
	touch $@

binary-indep: install-indep
	dh_testdir -i
	dh_testroot -i
	dh_installdirs -i
	dh_install -i
#	dh_movefiles -i
	dh_installdocs -i
	rm -rf debian/deal.ii-examples/usr/share/doc/deal.ii-examples/step-*/doc
	
# Fix example Makefiles
	for mfile in `ls debian/deal.ii-examples/usr/share/doc/deal.ii-examples/step-*/Makefile`; do \
	  mv $$mfile $$mfile.in; \
	  sed 's/$$D\/common/$$D/' < $$mfile.in | \
	    sed 's/$$D\/include\/deal\.II/\/usr\/include\/deal.II/' | \
	    sed 's/$$D/\/usr\/share\/deal.II/' | \
	    sed 's/debug-mode = on/debug-mode = off/' | \
	    grep -v 'D = ' > $$mfile; \
	  rm -f $$mfile.in; \
	done
# Fix Make.global_options
	rm -f debian/libdeal.ii-dev/usr/share/deal.II/Make.global_options*
	sed "s/`echo $(CURDIR) | sed 's/\//\\\\\//g'`/\/usr/" \
	  < common/Make.global_options.orig | \
	  sed 's/deal.II\/include/include\/deal.II/' \
	  > debian/libdeal.ii-dev/usr/share/deal.II/Make.global_options
# Removing the binaries that go in $(version)
	rm -f debian/libdeal.ii-dev/usr/share/deal.II/scripts/report_features \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/make_dependencies \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/expand_instantiations
# Link to scripts in $(version) and make "make_todo.pl" executable
	ln -s ../../../lib/deal.II-$(version)/make_dependencies \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/make_dependencies
	ln -s ../../../lib/deal.II-$(version)/report_features \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/report_features
	chmod +x debian/libdeal.ii-dev/usr/share/deal.II/scripts/make_todo.pl
# Remove backup files
	rm -f debian/libdeal.ii-dev/usr/include/deal.II/base/config.h.in~
	rm -f debian/libdeal.ii-dev/usr/share/deal.II/scripts/*.in \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/*.cc \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/make_tarfile.sh

	dh_installchangelogs -i
	dh_compress -i -XMakefile -Xcc -Xinp
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: install-arch
	dh_testdir -a
	dh_testroot -a
	dh_installdirs -a
	dh_install -a
#	dh_movefiles -a
#	install -d debian/libdeal.ii-dbg$(version)/usr/share/lintian/overrides
#	install -m 644 debian/libdeal.ii-dbg$(version).overrides \
#	  debian/libdeal.ii-dbg$(version)/usr/share/lintian/overrides/libdeal.ii-dbg$(version)
	dh_installdocs -a

	dh_installchangelogs -a
	dh_strip -a -X.g --dbg-package=libdeal.ii-dbg$(version)
	dh_makeshlibs -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep build build-arch build-indep clean
